#ifndef VEC2F_H
#define VEC2F_H

class Vec2f
{
public:
    Vec2f(const float _x = 0.0, const float _y = 0.0);

    float   squaredMag();
    float   mag();
    float   arg();
    void    setAngle(const float angle);
    void    normalize();
    float   dot(const Vec2f& a);
    float   cross(const Vec2f& a);

    Vec2f   operator+(const Vec2f& a);
    Vec2f&  operator+=(const Vec2f& a);
    Vec2f   operator-();
    Vec2f   operator-(const Vec2f& a);
    Vec2f&  operator-=(const Vec2f& a);
    Vec2f   operator*(const float m);
    Vec2f&  operator*=(const float m);
    Vec2f   operator/(const float m);
    Vec2f&  operator/=(const float m);

    float   x, y;
};

#endif
