#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"
#include "Maths.h"
#include "Vec2f.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

void drawShape(Vec2f* points, int nbPoints, Color color)
{
    for (int i = 0; i < nbPoints; i++)
    {
        int next = (i + 1) % nbPoints;
        gfx.line(points[i].x + SCREEN_WIDTH  / 2,
                 points[i].y + SCREEN_HEIGHT / 2,
                 points[next].x + SCREEN_WIDTH  / 2,
                 points[next].y + SCREEN_HEIGHT / 2,
                 color);
    }
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("2D Transforms", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();

    // define the shape
    Vec2f shape[] =
    {
        {-20, 20}, {-20, -20}, {30, 20}
    };

    // wait until we quit
    while (sys.isQuitRequested() == false)
    {
        gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

        drawShape(shape, 3, Color(0, 255, 255));

        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
